/*
 * Expressions evaluation program
 * Thomas Nemeth, 2003
 */


#ifndef EVAL_H
#define EVAL_H

#include <libepe/lists.h>

typedef struct {
    char   *name;
    double (*fct)();
    char   *cmp;    /* input should be gt(>), ge(>=), lt(<), le(<=), eq(=) */
    double  cval;   /* to cval */
} FctDef;


double opp(double x);

extern FctDef func_tab[];

/* Returns
 * 0     : ok
 * other : error (see get_errormsg)
 */
int eval(TFct *tree, TEnv *env, double *res);
int eval_function(const char *name, TEnv *env, double *res);
int eval_range(const char *name, TEnv *env, TFct **fct);

#endif
