/*
 * Expressions evaluation program
 * Thomas Nemeth, 2003
 */


#ifndef LOAD_H
#define LOAD_H

#include <libepe/lists.h>

/* Returns 'load' function errors or 0 */
ulong load_expression(const char *name, const char *var, const char *expr, TEnv *env);

/* Returns 'load' function errors + FCTLISTERR * fct_num or 0 */
ulong load_expressions(const char *exp_list, TEnv *env);

/* Returns VARLISTERR * var_num or 0 */
ulong load_variables(const char *var_list, TEnv *env);

/* Returns 0, UNKNOWNFILE, UNKNOWNENTRY, READERROR or
 * 'load' function errors + CFGFILEERR * line_num */
ulong load_config(const char *filename, TEnv *env);

void get_errormsg(char *msgstr, int maxlen, ulong errorcode);
 
#endif
