/*
 * xmem.c
 * Thomas Nemeth -- le 24 aot 2001
 *
 *   Copyright (C) 1999  Thomas Nemeth
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include "xmem.h"


void *xmalloc(size_t size) {
    void *ret = size > 0 ? malloc(size) : NULL;
    if ((size > 0) && (! ret)) {
        perror("malloc() ");
        exit(-1);
    } else
        return ret;
}


char *xstrdup(const char *string) {
    char *ret = string ? strdup(string) : NULL;
    if (string && (! ret)) {
        perror("strdup() ");
        exit(-1);
    } else
        return ret;
}

void strcatn(char *string, ulong size, char *addstr) {
    ulong l1 = (string && (string[0] != 0)) ? strlen(string) : 0;
    ulong l2 = (addstr && (addstr[0] != 0)) ? strlen(addstr) : 0;

    if (l1 >= size - 1) return;
    if (l1 + l2 < size - 1)
        strcat(string, addstr);
    else
        strncat(string, addstr, size - 1 - l1);
}
